<template>
    <div style="position: relative; left: 20px; margin: 10px">
        <div>{{ props.content }}</div>
        <div> {{ props.username }}</div>
        <div class="add-comment">
            <a v-if="typeof user.email !== 'undefined' && !addingComment" @click="() => { addingComment = true }">
                Add comment
            </a>
            <a v-if="addingComment" @click="() => { addingComment = false }">
                Cancel
            </a>
        </div>
        <el-button @click="expandRollUpComments" :icon="commentsExpanded ? ArrowUp : ArrowDown" circle />
        <div v-if="addingComment" class="adding-comment-wrapper">
            <el-input v-model="commentContent" placeholder="Comment" />
            <el-button @click="addComment" type="success" :icon="DArrowRight" circle />
        </div>
        <div v-if="commentsExpanded">
            <CommentComponent v-for="(comment, index) in comments" :key="index" :id="comment.id" :content="comment.content"
                :username="comment.userName" />
        </div>
    </div>
</template>
<script setup lang="ts">

import { ref, Ref } from 'vue';
import axios, { AxiosResponse } from 'axios';
import { ArrowDown, ArrowUp, DArrowRight } from '@element-plus/icons-vue';

import { useStore } from '../stores';
import { storeToRefs } from 'pinia';

import CommentComponent from './Comment.vue';

import Comment from '../interfaces/Comment';

interface Props {
    id: number,
    content: string,
    username: string
}

const store = useStore();
const { user } = storeToRefs(store);
const props = defineProps<Props>();
const comments: Ref<Comment[]> = ref([]);
const addingComment: Ref<boolean> = ref(false);
const commentContent: Ref<String> = ref('');
const commentsExpanded: Ref<boolean> = ref(false);


async function expandRollUpComments() {

    if (commentsExpanded.value) {
        commentsExpanded.value = false;
        return;
    };

    await getComments();
    commentsExpanded.value = true;

};

function addComment() {
    // @ts-ignore
    axios.post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/comment/comment/${props.id}`,
        { content: commentContent.value, uuid: user.value.uuid }
    ).then(({ data }:AxiosResponse) => {
        commentContent.value = '';
        commentsExpanded.value = true;
        getComments();
    }).catch(err => {
        console.error(err);
    })
};

function getComments() {
    // @ts-ignore
    axios.get(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/comment/comment/${props.id}`)
        .then(({ data }:AxiosResponse<Comment[]>) => {
            comments.value = data;
        }).catch(err => {
            console.error(err);
        })
};
</script>
<style scoped lang="scss">
.adding-comment-wrapper {
    display: flex;
    flex-direction: row;

    &>*:nth-child(1) {
        width: 80%;
    }
}
</style>